# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_izismile
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_izismile"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://izismile.com/videos/"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_izismile.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL
    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    patron  = '<div class="big_foto_block"[^<]+'
    patron += '<a[^<]+</a[^<]+'
    patron += '<H1[^>]+><a[^>]+>([^<]+)</a></H1>.*?'
    patron += 'image\: "([^"]+)".*?'
    patron += 'file\: "([^"]+)"'

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for title,thumbnail,url in matches:
        scrapedtitle = title
        scrapedurl = url
        scrapedthumbnail = thumbnail
        scrapedplot = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        itemlist.append( Item(channel=__channel__, action="play", server = "directo" , title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0