# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_joannecassey
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_joannecassey"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://joannecasey.blogspot.com.es"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_joannecassey.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL
    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    patron  = "<div class='post hentry'[^<]+"
    patron += "<a name='[^<]+</a>[^<]+"
    patron += "<h3 class='post-title entry-title' itemprop='name'>[^<]+"
    patron += "<a href='[^']+'>([^<]+)</a>(.*?)"
    patron += "<span class='post-labels'>(.*?)</span>"

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for title,body,labels in matches:
        scrapedtitle = title
        scrapedurl = ""
        scrapedthumbnail = ""
        scrapedplot = scrapertools.htmlclean(labels)
        scrapedplot = re.compile("\s+",re.DOTALL).sub(" ",scrapedplot)

        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        videoitemlist = servertools.find_video_items(data=body)
        if len(videoitemlist)>0:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitemlist[0].server , title=scrapedtitle , url=videoitemlist[0].url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0