# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_kotaro
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_kotaro"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://www.kotaro269.com/"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_kotaro.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL

    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    '''
    <a href="http://www.kotaro269.com/archives/51383207.html"><img src="http://resize.blogsys.jp/25899e01158674b0f35775d78b5ce3d6cf60db78/crop1/180x80/http://livedoor.blogimg.jp/kotaro269/imgs/7/f/7f29243a.jpg" alt="" /></a>
    <a href="http://www.kotaro269.com/archives/51383207.html">????22??????????????????????</a>
    </li>
    '''
    patron  = '<a href="([^"]+)"><img src="([^"]+)"[^<]+</a>[^<]+'
    patron += '<a href="[^"]+">([^<]+)</a>'

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for url,thumbnail,title in matches:
        scrapedtitle = title
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = thumbnail
        scrapedplot = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        videoitem = get_video_item(scrapedurl)
        if videoitem is not None:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitem.server , title=scrapedtitle , url=videoitem.url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

def get_video_item(url):
    logger.info("[rv_kotaro.py] get_media_url "+url)

    # plot and tags
    data = scrapertools.cache_page(url)
    videoitemlist = servertools.find_video_items(data=data)
    if len(videoitemlist)>0:
        return videoitemlist[0]
    else:
        try:
            mediaurl = scrapertools.get_match(data,"'file'\:\s+'([^']+)',")
            videoitem = Item(url=mediaurl, server="directo")
            return videoitem
        except:
            return None

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0