# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_tastelikepizza
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_tastelikepizza"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://tastelikepizza.com/index.php?catid=3&blogid=1"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_tastelikepizza.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL

    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    '''
    <div class="entry-titel"><a target="_self" href="http://tastelikepizza.com/item/2012/10/crazy-russian-fan-attacks-referee/category/3">Crazy Russian Fan Attacks Referee</a></div>
    <div class="entry-txt"><div class="rightbox"><a href="http://tastelikepizza.com/item/2012/10/crazy-fan-attacks-the-referee" target="_blank"><img src="http://tastelikepizza.com/media/1/20121001-attack.jpg" width="110" height="85" alt="Crazy Russian Fan Attacks Referee" title="Crazy Russian Fan Attacks Referee" /></a></div>Afgelopen weekend nog drukte de Belgische scheidsrechter Christof Dierick nog zijn stempel op de wedstrijd Heracles - Ado Den Haag door <a href="http://www.volkskrant.nl/vk/nl/10788/Eredivisie/article/detail/3324302/2012/09/29/Volop-spektakel-in-Almelo-met-3-benutte-penalty-s.dhtml" target="_blank">3 strafschoppen</a> te geven in 10 minuten. In Rusland kan dat natuurlijk niet, en schakelen we eventjes over naar de wedstrijd FC Metalist v Chernomorets die afgelopen vrijdag werd gespeeld en waar een fan de scheids zelfs aanvalt... <a href="http://tastelikepizza.com/item/2012/10/crazy-fan-attacks-the-referee" target="_blank">Hier de beelden!</a></div><div style="clear:both;"></div><hr color="#a4a4a4" />
    '''
    patron  = '<div class="entry-titel"><a target="_self" href="[^"]+">([^<]+)</a></div>[^<]+'
    patron += '<div class="entry-txt"><div class="rightbox"><a href="([^"]+)"[^<]+<img src="([^"]+)"[^<]+</a></div>(.*?)</div>'

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for title,url,thumbnail,plot in matches:
        scrapedtitle = title
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = thumbnail
        scrapedplot = scrapertools.htmlclean(plot)
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        videoitem = get_video_item(scrapedurl)
        if videoitem is not None:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitem.server , title=scrapedtitle , url=videoitem.url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

def get_video_item(url):
    logger.info("[rv_tastelikepizza.py] get_media_url "+url)

    # plot and tags
    data = scrapertools.cache_page(url)
    try:
        mediaurl = scrapertools.get_match(data,'file\:\s+"([^"]+)"')
        videoitem = Item(url=mediaurl, server="directo")
        return videoitem
    except:
        videoitemlist = servertools.find_video_items(data=data)
        if len(videoitemlist)>0:
            return videoitemlist[0]
        else:
            return None

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0