# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_thatvideosite
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_thatvideosite"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://www.thatvideosite.com/"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_thatvideosite.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL
    data = scrapertools.cachePage(item.url)
    logger.info("data="+data)

    # Extrae las entradas (carpetas)
    #<a href="/v/7003">
    #<img src="http://media.thatvideosite.com/core/7003/image_w_150.jpg" alt="How to cook the perfect steak" border="0" class="listimage" style="width: 150px; height: 84px; border-radius: 2px; border: 1px solid #919191; padding: 3px;">
    #</a><div class="playtime"><p class="playtime_content">4:44</p>
    patron  = '<a href="(/v/[^"]+)"[^<]+'
    patron += '<img src="([^"]+)" alt="([^"]+)"[^<]+'
    patron += '</a><div[^<]+'
    patron += '<p class="playtime[^>]+>([^<]+)<'
    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for url,thumbnail,title,duration in matches:
        scrapedtitle = title
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = thumbnail
        scrapedplot = duration
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        videoitem = get_video_item(scrapedurl)
        if videoitem is not None:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitem.server , title=scrapedtitle , url=videoitem.url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

def get_video_item(url):
    logger.info("[rv_thatvideosite.py] get_media_url "+url)

    # plot and tags
    data = scrapertools.cache_page(url)
    videoitemlist = servertools.find_video_items(data=data)
    if len(videoitemlist)>0:
        return videoitemlist[0]
    else:
        try:
            mediaurl = scrapertools.get_match(data,"'file'\:\s+'([^']+)',")
            videoitem = Item(url=mediaurl, server="directo")
            return videoitem
        except:
            return None

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0