# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_trendhure
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_trendhure"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://www.trendhure.com/category/filmchen/"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_trendhure.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL

    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    patron  = '<h1 class="storytitle"><a href="([^"]+)"[^>]+>([^<]+)</a[^<]+</h1>[^<]+'
    patron += '<div class="entry">[^<]+'
    patron += '<div class="center"><a[^<]+<img src="([^"]+)"[^<]+</a></div>[^<]+'
    patron += '<p>([^<]+)</p></div><!-- close entry -->'

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for url,title,thumbnail,plot in matches:
        scrapedtitle = title
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = thumbnail
        scrapedplot = plot
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        videoitem = get_video_item(scrapedurl)
        if videoitem is not None:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitem.server , title=scrapedtitle , url=videoitem.url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

def get_video_item(url):
    logger.info("[rv_trendhure.py] get_media_url "+url)

    # plot and tags
    data = scrapertools.cache_page(url)

    try:
        mediaurl = scrapertools.get_match(data,"'file'\:\s+'([^']+)',")
        videoitem = Item(url=mediaurl, server="directo")
        return videoitem
    except:
        return None

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0