# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_videosift
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_videosift"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://videosift.com/?sel=new"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_videosift.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL
    data = scrapertools.cachePage(item.url)

    # Extrae las entradas (carpetas)
    #<article id="video-238796" class="video-container listing-video videos-details" data-id="238796"><div class="headline"><header class="heading"><h2>
    #<a href="/skillful/video/Painting-like-a-Boss" title="Painting like a Boss!!!!">Painting like a Boss!!!!</a></h2></header><div class="tags"><strong>tags: </strong>
    #<ul id="tags-238796" class="tags-list"><li><a href="/skillful/tag/painting" rel="nofollow">painting</a></li><li>, <a href="/skillful/tag/spray+paint" rel="nofollow">spray paint</a></li><li>, <a href="/skillful/tag/fast" rel="nofollow">fast</a></li><li>, <a href="/skillful/tag/spacepaintings" rel="nofollow">spacepaintings</a></li><li>, <a href="/skillful/tag/brandon+mcconnell" rel="nofollow">brandon mcconnell</a></li></ul></div></div><div class="media-block"><div class="info-panel"><div id="votebtnup-238796"><a class="btn-top" rel="nofollow" href="/vote/39bb3e7671f6660bd21916ee13426c3b/238796?return=http%253A%252F%252Fbreakstheearth.videosift.com" title="vote this video up - you don't even have to be a member!" id="voteup-238796">&#9650;</a></div><strong class="value">26</strong><div id="votebtndown-238796"><a class="btn-down activate-login" rel="nofollow" href="/vote/0f8f1860323df1623caea3937066b356/238796?return=http%253A%252F%252Fbreakstheearth.videosift.com" title="vote this video down - bronze star members and above only" id="votedown-238796">&#9660;</a></div><ul><li><a href="/art"><span title="Arts" style="color:#B4100E">Art</span></a></li><li><a href="/spacy"><span title="The Clouds and Beyond">Spacy</span></a></li><li><a href="/skillful"><span title="Exceptionally skilled people" style="color:#2F4F4F">Skillful</span></a></li></ul></div><div class="img-box"><div class="video">
    #<img src="/i/loading.gif" alt="Loading video..."/></div><div class="img-frame"><a href="/skillful/video/Painting-like-a-Boss" class="thumb-expandable"><ul class="notes"></ul>
    #<img src="http://cdn.videosift.com/thumbs/p/ai/Painting_like_a_Boss.jpg?1355750745" alt="Expand Video" title="Expand Video"/></a></div><div class="actions"><a href="#" class="minimize-link">minimize video</a><div class="actions-holder"><a class="comments-value" href="/skillful/video/Painting-like-a-Boss#comments" id="commentshow-238796" title="comments (3)">3</a><ul><li class="js"><a class="embed" href="#" id="embed-238796" target="_blank" title="embed this video on your blog or website">embed</a></li><li><a class="email" href="/skillful/email/Painting-like-a-Boss" id="email-238796" target="_blank" title="email this video to a friend">email</a></li></ul></div><!--/ .holder --></div></div></div>
    #<div class="description"><p>This guy is so fast, it's freakin AMAZING!!!!!</p><span class="details">posted by <a href="/skillful/member/pumkinandstorm" title="member since March 27th, 2012" class="profilelink"><strong style="color:#f52c65">pumkinandstorm</strong></a>
    #<a href="/faq#stars"><img src="http://cdn.videosift.com/cdm/stars/01000.png" class="star" title="Ranked #12 - 42971 votes - 1252 star points" alt="" /></a> <span title="December 17th, 2012 5:25am PST">21 hours 29 minutes ago</span>&nbsp;&#8226;&nbsp;<span id="postviews-238796"  title="60 unique">317&nbsp;views</span>&nbsp;&#8226;&nbsp;1:33</span></div><div class="dynrow"></div></article>

    patron  = '<article id="video-\d+[^<]+<div[^<]+<header[^<]+<h2[^<]+'
    patron += '<a href="([^"]+)"[^>]+>([^<]+)</a.*?'
    patron += '<img src="(http[^"]+)".*?'
    patron += '<div class="description"><p>([^<]+)</p>'
    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for url,title,thumbnail,plot in matches:
        scrapedtitle = title
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = thumbnail
        scrapedplot = plot.strip()
        
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        videoitem = get_video_item(scrapedurl)
        if videoitem is not None:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitem.server , title=scrapedtitle , url=videoitem.url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

def get_video_item(url):
    logger.info("[rv_videosift.py] get_media_url "+url)

    # plot and tags
    data = scrapertools.cache_page(url)
    videoitemlist = servertools.find_video_items(data=data)
    if len(videoitemlist)>0:
        return videoitemlist[0]
    else:
        return None

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0