# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para rv_yourdailymedia
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "rv_yourdailymedia"

DEBUG = config.get_setting("debug")
MAIN_URL = "http://www.yourdailymedia.com/"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[rv_yourdailymedia.py] mainlist")

    itemlist = []

    # Descarga la pgina
    if item.url=="":
        item.url = MAIN_URL

    itemlist.extend(get_items(item.url))
    itemlist.extend(get_items("http://www.yourdailymedia.com/home/list/P10"))
    return itemlist

def get_items(mainurl):
    itemlist=[]
    data = scrapertools.cachePage(mainurl)
    # Extrae las entradas (carpetas)
    '''
    <div class="postContent">
    <div class="postTitle">
    <h2><a id="11814" class="frontpageTitle" href="/post/hilariously-retro-tobacco-ads/">Hilariously Retro Tobacco Ads</a></h2>
    </div>
    <div class="postShare">
    <div id="fbLike" class="fbLike">
    <div id="fb-root"></div>
    <fb:like href="http://www.yourdailymedia.com/post/hilariously-retro-tobacco-ads/"
    send="true" width="300" show_faces="false"></fb:like>
    </div>
    <div id="postIt" class="postIt">
    <div class="pw-widget pw_size_32 pw-counter-show" pw:copypaste="false">
    <a class="pw_facebook"></a>
    <a class="pw_twitter"></a>
    <a class="pw_stumble_upon"></a>
    <a class="pw_reddit"></a>
    <a class="pw_email"></a>
    <a class="pw-button-post"></a>
    <a class="pw_title" style="display:none">Hilariously Retro Tobacco Ads</a>
    <a class="pw_url" style="display:none">http://www.yourdailymedia.com/post/hilariously-retro-tobacco-ads/</a>
    </div>
    </div>
    </div>
    <div class="postBody">
    
    <p>Warning: these old ads for dipping tobacco may actually make you want to use the products. My favorite part is at 2:30 when Regis Philbin shills for the dip industry.</p><p><iframe width="620" height="465" src="http://www.youtube.com/embed/FDvRB7o2Nuo?t1m31s" frameborder="0" allowfullscreen=""></iframe></p>
    '''
    
    patron  = '<div class="postContent"[^<]+'
    patron += '<div class="postTitle"[^<]+'
    patron += '<h2><a.*?href="([^"]+)">([^<]+)</a></h2>.*?'
    patron += '<div class="postBody">(.*?)</div>'

    matches = re.compile(patron,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    for url,title,plot in matches:
        scrapedtitle = title
        scrapedurl = url
        scrapedthumbnail = ""
        scrapedplot = scrapertools.htmlclean(plot).strip()
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        videoitemlist = servertools.find_video_items(data=plot)
        if len(videoitemlist)>0:
            itemlist.append( Item(channel=__channel__, action="play", server = videoitemlist[0].server , title=scrapedtitle , url=videoitemlist[0].url , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=False) )

    return itemlist

# Verificacin automtica de canales: Esta funcin debe devolver "True" si est ok el canal.
def test():
    mainlist_items = mainlist(Item())
    return len(mainlist_items)>0